/* @(#)slo.h	1.5        (Pixar - RenderMan Division)    3/8/83 */

/*-______________________________________________________________________
** 
** Copyright (c) 1988 Pixar.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of Pixar.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
** 
**                      RESTRICTED RIGHTS NOTICE
** 
** Use, duplication, or disclosure by the Government is subject to
** restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
** Technical Data and Computer Software clause at 252.227-7013.
** 
** Pixar
** 3240 Kerner Blvd.
** San Rafael, CA  94901
** 
** ______________________________________________________________________
*/
#ifndef _SLO_
#define _SLO_

typedef enum {
    SLO_TYPE_UNKNOWN,
    SLO_TYPE_POINT,
    SLO_TYPE_COLOR,
    SLO_TYPE_SCALAR,
    SLO_TYPE_STRING,
/* The following types are primarily used for shaders */
    SLO_TYPE_SURFACE,
    SLO_TYPE_LIGHT,
    SLO_TYPE_DISPLACEMENT,
    SLO_TYPE_VOLUME,
    SLO_TYPE_TRANSFORMATION,
    SLO_TYPE_IMAGER
    } SLO_TYPE;

typedef enum {
    SLO_STOR_UNKNOWN,
    SLO_STOR_CONSTANT,
    SLO_STOR_VARIABLE,
    SLO_STOR_TEMPORARY,
    SLO_STOR_PARAMETER,
    SLO_STOR_GSTATE
    } SLO_STORAGE;

typedef enum {
    SLO_DETAIL_UNKNOWN,
    SLO_DETAIL_VARYING,
    SLO_DETAIL_UNIFORM
    } SLO_DETAIL;

/*vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*
 			Modified/added by JAD 09/22/89
 *vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/
#ifndef _SHADECON_
#define _SHADECON_
typedef struct {
    float	xval;
    float	yval;
    float	zval;
    } POINT;

typedef float SCALAR;
#endif

typedef struct slovissymdef {
    char *svd_name;
    SLO_TYPE svd_type;
    SLO_STORAGE svd_storage;
    SLO_DETAIL svd_detail;
    char *svd_spacename;
    union {
	POINT	*pointval;
	SCALAR	*scalarval;
	char	*stringval;
    } svd_default;
    union svd_defaultvalu {
	POINT	svd_pointval;
	SCALAR	svd_scalarval;
    } svd_defaultval;
    unsigned svd_valisvalid : 1;
} SLO_VISSYMDEF;

/*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^* 
 *^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*/

#define NULL_SLOVISSYMDEF ((SLO_VISSYMDEF *) 0)

#endif /* _SLO_ */
